# we don't want to provide private python extension libs
%{?filter_setup:
%filter_provides_in %{python_sitearch}/.*\.so$
%filter_setup
}

#define _version_suffix -f256

Name:           spice-gtk
Version:        0.14
Release:        7%{?dist}.3
Summary:        A GTK+ widget for SPICE clients

Group:          System Environment/Libraries
License:        LGPLv2+
URL:            http://spice-space.org/page/Spice-Gtk
Source0:        http://www.spice-space.org/download/gtk/%{name}-%{version}%{?_version_suffix}.tar.bz2
#upstream patches
Patch1:         0001-G_GNUC_DEPRECATED_FOR-must-be-defined-publicly.patch
Patch2:         0002-usb-Add-info-message-when-USB-dialog-is-empty.patch
Patch3:         0003-Set-channel-state-before-calling-channel_reset.patch
Patch4:         0004-channel-usbredir-Properly-reset-state-from-reset-cal.patch
Patch5:         0005-usb-redir-Fix-read-error-handling-depending-on-Spice.patch
Patch6:         0006-Rename-spice-usbredir-filter-option-to-spice-usbredi.patch
Patch7:         0007-Add-spice-usbredir-filter-alias-for-spice-usbredir-a.patch
Patch8:         0008-UsbDeviceManager-Add-a-redirect-on-connect-property.patch
Patch9:         0009-UsbDeviceManager-Build-channel-list-after-building-t.patch
Patch10:        0010-UsbDeviceManager-Hookup-redirect-on-connect-property.patch
Patch11:        0011-UsbDeviceManager-Don-t-warn-on-EINTR.patch
Patch12:        0012-Add-a-warning-if-scancode-lookup-failed.patch
Patch13:        0013-vnc-keymap-fix-incorrect-table-size.patch
Patch14:        0014-widget-apply-color-conversion-when-creating-image.patch
Patch15:        0015-spicy-show-the-correct-ungrab-key-combination.patch
Patch16:        0016-channel-inputs-Fix-sending-00-scancodes-to-guests-wi.patch
#Patch17:        0017-Print-list-of-supported-channels.patch
Patch18:        0018-channel-improve-debugging-message.patch
Patch19:        0019-Empty-host-subject-from-qemu-should-only-validate-ho.patch
Patch20:        0020-Fix-disabling-mouse-acceleration-on-X11.patch
Patch21:        0021-ssl-verify-use-more-explicit-error-message.patch
Patch22:        0022-acl-helper-policykit-policy-Allow-redir-by-default-f.patch
Patch23:        0023-Send-monitor-config-to-the-agent-on-spice_main_set_d.patch
Patch24:        0024-canvas_base-fix-not-caching-palettes-that-belong-to-.patch
Patch25:        0025-SECURITY-acl-helper-Use-ruid-of-invoker-rather-than-.patch

#these patches are not upstream until we make a decision on how we want to handle
#ctrl+alt+del exactly
Patch1000:      1000-Add-SpiceSession-disable-ctrlaltdel.patch
Patch1001:      1001-Block-ctrl-alt-del-if-the-corresponding-property-is-.patch

BuildRequires: intltool
BuildRequires: gtk2-devel >= 2.14
BuildRequires: usbredir-devel >= 0.5
BuildRequires: libusb1-devel >= 1.0.9
BuildRequires: libgudev1-devel
BuildRequires: pixman-devel openssl-devel libjpeg-devel
BuildRequires: celt051-devel pulseaudio-libs-devel
BuildRequires: pygtk2-devel python-devel zlib-devel
BuildRequires: cyrus-sasl-devel
BuildRequires: libcacard-devel
BuildRequires: libacl-devel
BuildRequires: polkit-devel
BuildRequires: usbutils
# needed for bz 799112
BuildRequires: spice-protocol
# Hack because of bz #613466
BuildRequires: libtool
Requires: spice-glib%{?_isa} = %{version}-%{release}
Requires: gtk2 >= 2.18.9-10

ExclusiveArch: %{ix86} x86_64

%description
Client libraries for SPICE desktop servers.

%package devel
Summary: Development files to build GTK2 applications with spice-gtk-2.0
Group: Development/Libraries
Requires: %{name}%{?_isa} = %{version}-%{release}
Requires: spice-glib-devel%{?_isa} = %{version}-%{release}
Requires: pkgconfig
Requires: gtk2-devel

%description devel
spice-client-gtk-2.0 provides a SPICE viewer widget for GTK2.

Libraries, includes, etc. to compile with the spice-gtk2 libraries

%package -n spice-glib
Summary: A GObject for communicating with Spice servers
Group: Development/Libraries
# Ensure we have a new enough libusb for usbredir
Requires: libusb1 >= 1.0.9

%description -n spice-glib
spice-client-glib-2.0 is a SPICE client library for GLib2.

%package -n spice-glib-devel
Summary: Development files to build Glib2 applications with spice-glib-2.0
Group: Development/Libraries
Requires: spice-glib%{?_isa} = %{version}-%{release}
Requires: pkgconfig
Requires: glib2-devel
Requires: spice-protocol

%description -n spice-glib-devel
spice-client-glib-2.0 is a SPICE client library for GLib2.

Libraries, includes, etc. to compile with the spice-glib-2.0 libraries

%package python
Summary: Python bindings for the spice-gtk-2.0 library
Group: Development/Libraries
Requires: %{name}%{?_isa} = %{version}-%{release}

%description python
SpiceClientGtk module provides a SPICE viewer widget for GTK2.

A module allowing use of the spice-gtk-2.0 widget from python

%package tools
Summary: Spice-gtk tools
Group: Applications/Internet
Requires: %{name}%{?_isa} = %{version}-%{release}

%description tools
Simple clients for interacting with SPICE servers.
spicy is a client to a SPICE desktop server.
snappy is a tool to capture screen-shots of a SPICE desktop.

%prep
%setup -q -n spice-gtk-%{version}%{?_version_suffix} -c

if [ -n '%{?_version_suffix}' ]; then
  mv spice-gtk-%{version}%{?_version_suffix} spice-gtk-%{version}
fi

pushd spice-gtk-%{version}
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
#%patch17 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1
%patch1000 -p1
%patch1001 -p1
find . -name '*.stamp' | xargs touch
popd


%build
cd spice-gtk-%{version}
%configure --disable-gtk-doc --with-gtk=2.0 --disable-introspection --with-usb-acl-helper-dir=%{_libexecdir}/spice-gtk-%{_arch}/
make %{?_smp_mflags}
cd ..

%install
cd spice-gtk-%{version}
make install DESTDIR=%{buildroot}
rm -f %{buildroot}%{_libdir}/*.a
rm -f %{buildroot}%{_libdir}/*.la
rm -f %{buildroot}%{_libdir}/python*/site-packages/*.a
rm -f %{buildroot}%{_libdir}/python*/site-packages/*.la
%find_lang %{name}
cd ..

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%post -n spice-glib -p /sbin/ldconfig
%postun -n spice-glib -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%doc spice-gtk-%{version}/AUTHORS
%doc spice-gtk-%{version}/COPYING
%doc spice-gtk-%{version}/README
%doc spice-gtk-%{version}/NEWS
%{_libdir}/libspice-client-gtk-2.0.so.*

%files devel
%defattr(-,root,root,-)
%{_libdir}/libspice-client-gtk-2.0.so
%{_includedir}/spice-client-gtk-2.0
%{_libdir}/pkgconfig/spice-client-gtk-2.0.pc

%files -n spice-glib -f spice-gtk-%{version}/%{name}.lang
%defattr(-,root,root,-)
%{_libdir}/libspice-client-glib-2.0.so.*
%{_libdir}/libspice-controller.so.*
%{_libexecdir}/spice-gtk-%{_arch}/spice-client-glib-usb-acl-helper
%{_datadir}/polkit-1/actions/org.spice-space.lowlevelusbaccess.policy

%files -n spice-glib-devel
%defattr(-,root,root,-)
%{_libdir}/libspice-client-glib-2.0.so
%{_libdir}/libspice-controller.so
%{_includedir}/spice-client-glib-2.0
%{_includedir}/spice-controller/*
%{_libdir}/pkgconfig/spice-client-glib-2.0.pc
%{_libdir}/pkgconfig/spice-controller.pc
%{_datadir}/vala/vapi/spice-protocol.vapi
%doc %{_datadir}/gtk-doc/html/*

%files python
%defattr(-,root,root,-)
%{_libdir}/python*/site-packages/SpiceClientGtk.so

%files tools
%defattr(-,root,root,-)
%{_bindir}/snappy
%{_bindir}/spicy
%{_bindir}/spicy-stats

%changelog
* Thu Sep 12 2013 Christophe Fergeau <cfergeau@redhat.com> 0.14-7.3
- New build with correct patch for CVE-2013-4324

* Wed Sep 11 2013 Christophe Fergeau <cfergeau@redhat.com> 0.14-7.2
- Fix race condition in policykit use (CVE-2013-4324)
  Resolves: CVE-2013-4324

* Mon Jul 29 2013 Christophe Fergeau <cfergeau@redhat.com> 0.14-7.1
- Fix crash when pressing ctrl+shift+v in outlook
  Resolves: rhbz#988924

* Thu Jan 10 2013 Hans de Goede <hdegoede@redhat.com> - 0.14-7
- Update agent monitor settings when closing a window
  Resolves: rhbz#881072

* Fri Dec 21 2012 Christophe Fergeau <cfergeau@redhat.com> - 0.14-6
- Don't ask for root/admin password when users want to redirect USB
  devices
  Resolves: rhbz#859392

* Tue Oct 23 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.14-5
- Apply color conversion when creating image
  Resolves: rhbz#843134
- Show correct ungrab key combination in spicy
  Resolves: rhbz#851090
- Fix sending 00 scancodes to guests
  Resolves: rhbz#868237
- Improve open_host() debugging message
  Resolves: rhbz#858232
- Empty host subject from qemu should only validate hostname
  Resolves: rhbz#858228
- Fix disabling mouse acceleration on X11
  Resolves: rhbz#867885
- use more explicit SSL error message
  Resolves: rhbz#846666

* Mon Oct 15 2012 Christophe Fergeau <cfergeau@redhat.com> - 0.14-4
- Fix application of Patch2, it includes the git commit log which
  contained a diff hunk which %patch happily applied, which caused
  https://bugzilla.redhat.com/show_bug.cgi?id=804187#c9
  Related: rhbz#804187

* Thu Oct 11 2012 Christophe Fergeau <cfergeau@redhat.com> - 0.14-3
- Add info message when USB dialog is empty
  Resolves: rhbz#804187
- Properly reset usb channels after non-seamless migration
  Resolves: rhbz#861332
- Fix read error handling for USB redirection
  Related: rhbz#842354
- Auto-discover already plugged-in USB devices
  Resolves: rhbz#820964
- Add support for disabling Ctrl+Alt+Del
  Resolves: rhbz#807771

* Tue Sep 25 2012 Christophe Fergeau <cfergeau@redhat.com> - 0.14-2
- Readd G_GNUC_DEPRECATED_FOR patch as this issue is not fixed upstream yet
  Related: rhbz#842354

* Fri Sep 21 2012 Christophe Fergeau <cfergeau@redhat.com> - 0.14-1
- Rebase spice-gtk to 0.14
  Resolves: rhbz#842354

* Mon Sep 10 2012 Christophe Fergeau <cfergeau@redhat.com> - 0.13.29-3
- Add patch fixing CVE-2012-3524
  Resolves: rhbz#854825

* Tue Sep 4 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.13.29-2
- Rebase spice-gtk to latest upstream (with SPICE_DEPRECATED_FOR macro)
  Resolves: rhbz#842354

* Tue Sep 4 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.13.29-1
- Rebase spice-gtk to latest upstream
  Resolves: rhbz#842354

* Wed May 23 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.11-11
- Correctly track main channel, fix crash in some migration cases
  Resolves: rhbz#823874

* Thu May 17 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.11-10
- Fix channel caps not being reset correctly, and causing migration to fail
  Resolves: rhbz#821795

* Sun May 6 2012 Yonit Halperin     <yhalperi@redhat.com> - 0.11-9
- Introduce sized video frames, for fixing glitches in youtube movies.
  Resolves: rhbz#815426

* Mon Apr 16 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.11-8
- Fix switch-host migration error with ssl channels.
  Resolves: rhbz#802574

* Tue Apr 10 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.11-7
- Handle grab-broken event
  Resolves: rhbz#807292
- Fix segfault with large clipboard copy-paste
  Resolves: rhbz#809145
- Fix cursor not hidden
  Resolves: rhbz#810588
- Fix segfault when closing while recording
  Resolves: rhbz#810247
- Add USB support to controller
  Resolves: rhbz#807296
- Add WAN support to controller
  Resolves: rhbz#787449

* Tue Apr 03 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.11-6
- Fix blue-tinted video with old Spice server
  Resolves: rhbz#807389
- Fix segfault during switch-host migration
  Resolves: rhbz#807410
- Fix switch-host migration failure with SSL
  Resolves: rhbz#802574
- Fix crash during migration while playing video
  Resolves: rhbz#808567
- Requires gtk2 >= 2.18.9-10
  Resolves: rhbz#809033

* Thu Mar 22 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.11-5
- Fix memory leak when resizing guest
  Resolves: rhbz#805641

* Wed Mar 21 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.11-4
- Fix cursor is displayed on each guest screen when mouse is in server mode
  Resolves: rhbz#804308

* Wed Mar 21 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.11-3
- Fix cursor is displayed on each guest screen when mouse is in server mode
  Resolves: rhbz#804308
- Fix --spice-color-depth=16 does not seem to work.
  Resolves: rhbz#802898
- Fix cannot leave full-screen when mouse is grabbed in server mode mouse
  Resolves: rhbz#804307

* Wed Mar 14 2012 Hans de Goede <hdegoede@redhat.com> - 0.11-2
- Fix a crash triggered when trying to view a usbredir enabled vm from
  virt-manager
  Related: rhbz#758100

* Thu Mar 08 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.11-1
- Rebase to 0.11 upstream release
  Related: rhbz#773642

* Wed Mar 07 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.10.6-3
- Add back spice-protocol BuildRequires to help some deps magic happen.
  Resolves: #799112

* Thu Mar 06 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.10.6-2
- spice-client-glib-devel requires spice-protocol.
  Resolves: #799112
- seam-less migration fix.

* Thu Mar 01 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.10.6-1
- Add foreign menu support.
  Related: rhbz#773642

* Fri Feb 24 2012 Hans de Goede <hdegoede@redhat.com> - 0.10-1
- Rebase to 0.10 upstream release
  Related: rhbz#773642

* Tue Jan 31 2012 Hans de Goede <hdegoede@redhat.com> - 0.9-1
- Rebase to 0.9 upstream release
  Related: rhbz#773642

* Wed Jan 25 2012 Hans de Goede <hdegoede@redhat.com> - 0.8-1
- Rebase to 0.8 upstream release
  Resolves: rhbz#773642
- This release add support for usbredirection
  Resolves: rhbz#758100
- This release fixes spice-gtk crashing on machines with no soundcard
  Resolves: rhbz#772118

* Mon Jul 18 2011 Christophe Fergeau <cfergeau@redhat.com> - 0.6-2
- Set release to -2 so that the EPEL package gets upgraded
- Related: rhbz#708417

* Mon Jul 18 2011 Christophe Fergeau <cfergeau@redhat.com> - 0.6-1
- Added spice-gtk-0.6-add-generated-files.patch to be able to build without
  perl-Text-CSV
- Initial import of spice-gtk in RHEL CVS based on the EPEL .spec
- Related: rhbz#708417

* Fri May 27 2011 Christophe Fergeau <cfergeau@redhat.com> - 0.6-1
- Initial EPEL release based on the rawhide .spec cleaned up from the parts
  that are not useful for EPEL (because the needed dependencies are not available)

* Wed May 25 2011 Christophe Fergeau <cfergeau@redhat.com> - 0.6-1
- Upstream release 0.6

* Tue Mar  1 2011 Hans de Goede <hdegoede@redhat.com> - 0.5-6
- Fix spice-glib requires in .pc file (#680314)

* Fri Feb 11 2011 Matthias Clasen <mclasen@redhat.com> - 0.5-5
- Fix build against glib 2.28

* Thu Feb 10 2011 Matthias Clasen <mclasen@redhat.com> - 0.5-4
- Rebuild against newer gtk

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Feb  2 2011 Matthias Clasen <mclasen@redhat.com> - 0.5-2
- Rebuild against newer gtk

* Thu Jan 27 2011 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5-1
- Upstream release 0.5

* Fri Jan 14 2011 Daniel P. Berrange <berrange@redhat.com> - 0.4-2
- Add support for parallel GTK3 build

* Mon Jan 10 2011 Dan Horák <dan[at]danny.cz> - 0.4-2
- add ExclusiveArch as only x86 is supported

* Sun Jan 09 2011 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.4-1
- Upstream release 0.4
- Initial release (#657403)

* Thu Nov 25 2010 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.1.0-1
- Initial packaging
